#! /bin/bash

Encoding=UTF-8
export PATH=":${PATH:-"/usr/bin:/bin:/usr/local/bin"}"
export LD_LIBRARY_PATH="/mnt/utmp/daphne/lib:${LD_LIBRARY_PATH:-"/usr/lib:/lib"}"
export HOME="/mnt/utmp/daphne" XDG_CONFIG_HOME="/mnt/utmp/daphne"
export SDL_AUDIODRIVER="alsa"

export SDL_VIDEODRIVER="omapdss"
export SDL_OMAP_VSYNC="1"


mkdir framefile
mkdir roms
mkdir mpeg
mkdir mpeg/lair
mkdir ram
cp -n defconf/* .

FILE_BROWSE="./roms/"
export PIC="/mnt/utmp/daphne/titles/lair.png"

export MAIN_DIALOG='
<window window_position="1" title="PanDaphne" decorated="false"	width_request="800" height_request="480">

<notebook labels="Main|Config">
<vbox>
<frame Other>
   <checkbox>
    <label>Enable Cheats</label>
    <input>echo $(head -n 1 enablecheats)</input>
    <variable>ENABLE_CHEATS</variable>
    <action>echo $ENABLE_CHEATS > enablecheats</action>
   </checkbox>

</frame>
<frame DipSwitches>
<hbox>
<entry>
    <input>echo $(head -n 1 bank3set)</input>
    <variable>BANK3SET</variable>
    <action>echo $BANK3SET > bank3set</action>
   </entry>
  <checkbox>
    <label>Bank 3</label>
    <input>echo $(head -n 1 bank3)</input>
    <variable>BANK3</variable>
    <action>echo $BANK3 > bank3</action>
  </checkbox>
</hbox>
<hbox>
<entry>
    <input>echo $(head -n 1 bank2set)</input>
    <variable>BANK2SET</variable>
    <action>echo $BANK2SET > bank2set</action>
   </entry>
 <checkbox>
    <label>Bank 2</label>
    <input>echo $(head -n 1 bank2)</input>
    <variable>BANK2</variable>
    <action>echo $BANK2 > bank2</action>
  </checkbox>
</hbox>
<hbox>
 <entry>
    <input>echo $(head -n 1 bank1set)</input>
    <variable>BANK1SET</variable>
    <action>echo $BANK1SET > bank1set</action>
   </entry>
 <checkbox>
    <label>Bank 1</label>
    <input>echo $(head -n 1 bank1)</input>
    <variable>BANK1</variable>
    <action>echo $BANK1 > bank1</action>
  </checkbox>
</hbox>
<hbox>
  <button help>
    <action>zenity --info --text="Modify dip switch settings. The value is entered in 8-bit binary, what is composed from 1 and 0. The right most bit corresponds to the first dip switch. For example, if you want to enable dip switch 0 but want to disable 1-7, you would enter 00000001"</action>  
   </button>
   <entry>
    <input>echo $(head -n 1 bank0set)</input>
    <variable>BANK0SET</variable>
    <action>echo $BANK0SET > bank0set</action>
   </entry>
 <checkbox>
    <label>Bank 0</label>
    <input>echo $(head -n 1 bank0)</input>
    <variable>BANK0</variable>
    <action>echo $BANK0 > bank0</action>
  </checkbox>
</hbox>
</frame>
   <frame Sound>
   <checkbox>
    <label>Disable sound</label>
    <input>echo $(head -n 1 sounddisabled)</input>
    <variable>SOUND_DISABLED</variable>
    <action>echo $SOUND_DISABLED > sounddisabled</action>
   </checkbox>
<hbox>
   <button help>
    <action>zenity --info --text="Sets the number of samples in the soundbuffer. Lower values make the sound more responsive but choppier, while large values make the sound smoother but more sluggish."</action>  
   </button>
   <entry>
    <input>echo $(head -n 1 soundbuffer)</input>
    <variable>SOUND_BUFFER</variable>
    <action>echo $SOUND_BUFFER > soundbuffer</action>
   </entry>
   <text>
    <label>Buffer (Default: 2048)</label>
   </text>
</hbox>
   </frame>
   <frame Graphics>
   <checkbox>
    <label>Stretch to fullscreen</label>
    <input>echo $(head -n 1 fullscreen)</input>
    <variable>FULLSCREEN</variable>
    <action>echo $FULLSCREEN > fullscreen</action>
   </checkbox>
   <checkbox>
    <label>Disable overlay</label>
    <input>echo $(head -n 1 overlaydisabled)</input>
    <variable>OVERLAY_DISABLED</variable>
    <action>echo $OVERLAY_DISABLED > overlaydisabled</action>
   </checkbox>
 <hbox>
   <button help>
    <action>zenity --info --text="Possible values: 0/1 - Enables a graphical scoreboard for Dragons Lair, Space Ace or Thayers Quest. The number chooses the style of the scoreboard."</action>  
   </button>
   <entry>
    <input>echo $(head -n 1 overlay)</input>
    <variable>OVERLAY</variable>
    <action>echo $OVERLAY > overlay</action>
   </entry>
   <text>
    <label>Overlay (Default:1)</label>
   </text>
   </hbox>
   </frame>
 </vbox>
 <vbox>
  <button cancel>
   </button>
  <button>
     <label>Launch Daphne</label>
     <action>export LD_LIBRARY_PATH="/mnt/utmp/daphne/lib:${LD_LIBRARY_PATH:-"/usr/lib:/lib"}" && export SDL_VIDEODRIVER="omapdss" && ROMBASE=`basename $(head -n 1 rom)` && ROMLAUNCH=${ROMBASE%\.*} && if [[ $FULLSCREEN == "true" ]]; then export SDL_OMAP_LAYER_SIZE="800x480"; else export SDL_OMAP_LAYER_SIZE="640x480"; fi && if [[ $SOUND_DISABLED == "true" ]]; then SOUND_1="-nosound"; else SOUND_1=""; fi && if [[ BANK0 == "true" ]]; then BANK_0="-bank 0 $BANK0SET"; else BANK_0=""; fi && if [[ BANK1 == "true" ]]; then BANK_1="-bank 1 $BANK1SET"; else BANK_1=""; fi && if [[ BANK2 == "true" ]]; then BANK_2="-bank 2 $BANK2SET"; else BANK_2=""; fi && if [[ BANK3 == "true" ]]; then BANK_3="-bank 3 $BANK3SET"; else BANK_3=""; fi && if [[ $OVERLAY_DISABLED == "true" ]]; then OVERLAY_2=""; else OVERLAY_2="$OVERLAY"; fi && if [[ $OVERLAY_DISABLED == "false" ]]; then OVERLAY_1="-useoverlaysb"; else OVERLAY_1=""; fi && if [[ $SOUND_DISABLED == "false" ]]; then SOUND_2="-sound_buffer"; else SOUND_2=""; fi && if [[ $SOUND_DISABLED == "false" ]]; then SOUND_3="$SOUND_BUFFER"; else SOUND_3=""; fi && if [[ $ENABLE_CHEATS == "true" ]]; then CHEAT_1="-cheat"; else CHEAT_1=""; fi && ./daphne.bin "$ROMLAUNCH" vldp -framefile "$FRAME" -fullscreen -homedir . $OVERLAY_1 $OVERLAY_2 $SOUND_1 $SOUND_2 $SOUND_3 $CHEAT_1 $BANK_0 $BANK_1 $BANK_2 $BANK_3</action>
   </button>
<frame Select framefile>
<hbox>
 <entry>
   <variable>FRAME</variable>
   <input>echo $(head -n 1 frame)</input>
   <action>echo $FRAME > frame</action>
 </entry>
 <button>
  <input file stock="gtk-open"></input>
  <action type="fileselect">FRAME</action>
 </button>
</hbox>
</frame>
<frame Select rom>
<hbox>
 <entry>
   <variable>ROM</variable>
   <input>echo $(head -n 1 rom)</input>
   <action>echo $ROM > rom</action>
 </entry>
 <button>
  <input file stock="gtk-open"></input>
  <action type="fileselect">ROM</action>
 </button>
</hbox>
</frame>
   <pixmap>
       <input file>"daphne.png"</input>
   </pixmap>
 </vbox>
</notebook>
 </window>'

./gtkdialog --program MAIN_DIALOG

